#include "udemoprivate.h"
//implementation of interface between spectator and demo driver

//todo: this :p

IMPLEMENT_CLASS(UDemoInterface);
//returns the timestamp demo started at
void UDemoInterface::execGetStartTime (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execGetStartTime);
	P_FINISH;
	*(FLOAT*)Result = DemoDriver->StartTime.GetFloat();
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execGetStartTime);

//sets the playback mode (timebased, framebased, noframecap)
void UDemoInterface::execSetPlayBackMode (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execSetPlayBackMode);
	P_GET_BYTE(PMode);
	P_FINISH;
	if (PMode==PlayBackMode)
		return;
	if (PMode == 0 && PlayBackMode == 1) //going to timebased from framebased. synch!
		DemoDriver->Time = DemoDriver->ServerPacketTime;
	DemoDriver->TimeBased = false;
	DemoDriver->NoFrameCap = false;
	if (PMode == 2){ //no frame cap!
		DemoDriver->NoFrameCap = true;
		DemoSpec->Level->TimeDilation = DemoDriver->RealDilation;
	}
	else //allow speed control!
		DemoSpec->Level->TimeDilation = DemoDriver->RealDilation*DemoDriver->Speed;
	if (PMode == 0) //time based
		DemoDriver->TimeBased = true;
	
	PlayBackMode = PMode;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execSetPlayBackMode);

//safely pause a demo... note: uscript should check for admin pause state!
void UDemoInterface::execPauseDemo (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execPauseDemo);
	P_GET_UBOOL(doPause);
	P_FINISH;
	DemoDriver->Paused=doPause;
	if (doPause)
		DemoSpec->Level->Pauser=TEXT("ClientPaused"); //flag.. hack sorta.
	else
		DemoSpec->Level->Pauser=TEXT("");
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execPauseDemo);

//determine how demo is currently paused
void UDemoInterface::execIsPaused (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execIsPaused);
	P_FINISH;
	if (DemoDriver->Paused)
		*(BYTE*)Result = 2;
	else if (DemoSpec->Level->Pauser!=TEXT("")) //admin paused
		*(BYTE*)Result = 1;
	else
		*(BYTE*)Result = 0;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execIsPaused);

//return total ammount of frames in the demo
void UDemoInterface::execGetTotalFrames (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execGetTotalFrames);
	P_FINISH;
	*(INT*)Result = DemoDriver->TotalFrames;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execGetTotalFrames);

//return the current frame demo is on (i.e. last framenum in packet read) - start
void UDemoInterface::execGetCurrentFrame (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execGetCurrentFrame);
	*(INT*)Result = DemoDriver->ServerFrameNum;
	P_FINISH;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execGetCurrentFrame);

//return the total playtime (at default speed) of demo
void UDemoInterface::execGetTotalTime (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execGetTotalTime);
	*(FLOAT*)Result = DemoDriver->TotalTime.GetFloat();
	P_FINISH;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execGetTotalTime);

//return the current Timestamp of demo (last one in packet read) - start
void UDemoInterface::execGetCurrentTime (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execGetCurrentTime);
	*(FLOAT*)Result = DemoDriver->ServerPacketTime.GetFloat();
	P_FINISH;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execGetCurrentTime);

//read x ammount while ticking all actors
void UDemoInterface::execReadCache (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execReadCache);
	P_GET_FLOAT(TimeTo);
	P_GET_FLOAT(inc); //increment
	P_FINISH;
	FTime Res;
	BYTE Done = 0;
	check(inc>0);
	check(DemoSpec->XLevel);
	check(DemoSpec->XLevel->Actors.Num());
	DemoDriver->bNoTick=true;
	while(true){ //go until done!
		Res = DemoDriver->ReadTo(DemoDriver->ServerPacketTime + inc);
		if (TimeTo-Res.GetFloat()<inc)
			Done = 1;
		guard(ActorTick); //actor ticking crashes.locks up UT. fix0r it!!!
		for( INT i=0; i<DemoSpec->XLevel->Actors.Num(); i++ )
			if (DemoSpec->XLevel->Actors(i)&&!DemoSpec->XLevel->Actors(i)->bIsPawn) //don't tick pawns (auto-move)
				DemoSpec->XLevel->Actors(i)->Tick(inc*DemoDriver->RealDilation,LEVELTICK_All);
		//DemoSpec->XLevel->TickDemoPlayback(inc);
		unguard;
		if (Done)
			break;
	}
	if (TimeTo-Res.GetFloat()>0){ //final cache thing
		DemoDriver->ReadTo(TimeTo);
		guard(ActorTick2);
		for( INT i=0; i<DemoSpec->XLevel->Actors.Num(); i++ )
			if (DemoSpec->XLevel->Actors(i)&&!DemoSpec->XLevel->Actors(i)->bIsPawn) //don't tick pawns!!!!
				DemoSpec->XLevel->Actors(i)->Tick((TimeTo-Res.GetFloat())*DemoDriver->RealDilation,LEVELTICK_All);
		
		//DemoSpec->XLevel->TickDemoPlayback(TimeTo-Res.GetFloat());
		unguard;
	}
	DemoDriver->bNoTick=false;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execReadCache);

//read until a specified time is reached!
void UDemoInterface::execReadTo (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execReadTo);
	P_GET_FLOAT(TimeTo);
	P_FINISH;
	//update levelinfo!
	DemoSpec->Level->Tick((TimeTo-DemoDriver->ServerPacketTime.GetFloat())*DemoDriver->RealDilation,LEVELTICK_All);
	DemoDriver->ReadTo(FTime(TimeTo));
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execReadTo);

//jump back to beginning, killing all actors spawned after playerpawn!
void UDemoInterface::execJumpBack (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execJumpBack);
	P_FINISH;
	guard(actorDestroy);
//	for( INT i=0; i<DemoSpec->XLevel->Actors.Num(); i++ )
//		if (DemoSpec->XLevel->Actors(i)&&DemoSpec->XLevel->Actors(i) != DemoSpec &&/* !DemoSpec->XLevel->Actors(i)->bDifficulty3 && */!DemoSpec->XLevel->Actors(i)->bStatic)
//			DemoSpec->XLevel->DestroyActor(DemoSpec->XLevel->Actors(i),1); //even if net!
	guard(ActorCleanUp);
//	DemoSpec->XLevel->CleanupDestroyed(true); //eh?
	unguard;
	unguard;
	DemoDriver->FileAr->Seek(0); //at beginning
	DemoSpec->Level->TimeSeconds=0;
	//DemoDriver->ReadTo(DemoDriver->StartTime, false); //complete jmup
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execJumpBack);

//set the speed of playback SHOULD NEVER BE CALLED IF NOFRAMECAP IS ACTIVE!
void UDemoInterface::execSetSpeed (FFrame& Stack, RESULT_DECL){ 
	guard (UDemoInterface::execSetSpeed);
	P_GET_FLOAT(newSpeed);
	P_FINISH;
	mySpeed = newSpeed;
	if (PlayBackMode != 2) //not in timebased!
		DemoSpec->Level->TimeDilation=newSpeed*(DemoDriver->RealDilation); //ratios own!
	DemoDriver->Speed = newSpeed;
	unguard;
}
IMPLEMENT_FUNCTION (UDemoInterface,-1,execSetSpeed);