#include "udemoprivate.h"
//begin custom demo driver
UuDemoDriver::UuDemoDriver()
{
//	Speed=1;
//	RealDilation=1;
}
void UuDemoDriver::StaticConstructor()
{
	guard(UuDemoDriver::StaticConstructor);
	new(GetClass(),TEXT("DemoSpectatorClass"), RF_Public)UStrProperty(CPP_PROPERTY(DemoSpectatorClass), TEXT("Client"), CPF_Config);
//	Speed=1;
//	RealDilation=1;
	unguard;
}
void UuDemoDriver::TickDispatch( FLOAT DeltaTime ){
	guard(UuDemoDriver:TickDispatch);
	if (bNoTick) //hack
		return;
	if(  ServerConnection){
		if (!NoFrameCap)
			DeltaTime*=Speed; //alter speed! 
		if (Paused)
			return;
	}
	UNetDriver::TickDispatch( DeltaTime );
	FrameNum++;
	UBOOL CheckTime = (ServerConnection->State == USOCK_Pending); //true if should set starttime
	BYTE Data[520]; //512+8
	FTime OldTime;
	int oldFrame;
	if(  ServerConnection && 
		(ServerConnection->State==USOCK_Pending || ServerConnection->State==USOCK_Open) )
	{	
		// Read data from the demo file
		DWORD PacketBytes;
		INT PlayedThisTick = 0;
		for( ; ; )
		{
			// At end of file?
			if( FileAr->AtEnd() || FileAr->IsError() )
			{
			AtEnd:
				ServerConnection->State = USOCK_Closed;
				DemoEnded = 1;
				if( Loop || MessagePlay)
					GetLevel()->Exec( *(FString(TEXT("DEMOPLAY "))+(*LoopURL.String())), *GLog );
				return;
			}
			oldFrame = ServerFrameNum;
			OldTime = ServerPacketTime;
			*FileAr << ServerFrameNum;
			*FileAr << ServerPacketTime;
			if(!MessagePlay && ((!TimeBased && ServerFrameNum > FrameNum) || (TimeBased && ServerPacketTime > Time)))
			{
				if(CheckTime && ServerConnection->State == USOCK_Pending)
					StartTime = ServerPacketTime; //set start to packet after welcome?
				FileAr->Seek(FileAr->Tell() - sizeof(ServerFrameNum) - sizeof(ServerPacketTime));
				ServerPacketTime = OldTime;
				ServerFrameNum = oldFrame;
				if (NoFrameCap && !TimeBased) //sync time 
					Time = OldTime;			
				else if (TimeBased) //sync frames (only for transitions)
					FrameNum=oldFrame;
				break;
			}
			if(!MessagePlay && !NoFrameCap && !TimeBased && ServerPacketTime > Time)
			{
				// Busy-wait until it's time to play the frame.
				// WARNING: use appSleep() if appSeconds() isn't using CPU timestamp!
				// appSleep(ServerPacketTime - Time);
				appSleep(ServerPacketTime - Time);
			}
			//sync level time with demo!
			else if (NoFrameCap && GetLevel() && GetLevel()->GetLevelInfo() ) 
				GetLevel()->GetLevelInfo()->TimeDilation = RealDilation+(ServerPacketTime - Time);

			//alter timedilation with nofcap here!!!!
			*FileAr << PacketBytes;
			//stops crashes on truncated demos:
			if ((FileAr->Tell() + PacketBytes) > (unsigned int) FileAr->TotalSize()) 
				goto AtEnd;
			// Read data from file.
			FileAr->Serialize( Data, PacketBytes );
			if( FileAr->IsError() )
			{
				debugf( NAME_DevNet, TEXT("Failed to read demo file packet") );
				goto AtEnd;
			}

			// Update stats.
			if( PacketBytes )
				PlayedThisTick++;
			// Process incoming packet.
			float oldDilation = 0.0;
			if (GetLevel() && GetLevel()->GetLevelInfo())
				oldDilation = GetLevel()->GetLevelInfo()->TimeDilation;
			ServerConnection->ReceivedRawPacket( Data, PacketBytes );
			if (GetLevel() && GetLevel()->GetLevelInfo() && abs(GetLevel()->GetLevelInfo()->TimeDilation-oldDilation) >0.01){
					RealDilation=GetLevel()->GetLevelInfo()->TimeDilation;
					if (!NoFrameCap)
						GetLevel()->GetLevelInfo()->TimeDilation*=Speed;
			}		
			
			if (MessagePlay && Interface)
				Interface->eventNetPacketReceived(); //notify new packet!

			// Only play one packet per tick on demo playback, until we're 
			// fully connected.  This is like the handshake for net play.
			if(ServerConnection->State == USOCK_Pending)
				break;
		}
	}
	unguard;

 }

ULevel* UuDemoDriver::GetLevel() //got rid of stupid, annoying check for level!
{
	guard(UuDemoDriver::GetLevel);
	check(Notify);
	return Notify->NotifyGetLevel();
	unguard;

}
//reads to just before time! (or at time if not by packets!) Returns time hit!
FTime UuDemoDriver::ReadTo(FTime GoalTime, UBOOL bPacketRead){
	guard(UuDemoDriver::ReadTo);
	int seekTo;
	DWORD PacketBytes; 
	FTime OldTime;
	int oldFrame;
	BYTE Data[520]; //512+8
	check(ServerConnection);
	while (!FileAr->AtEnd() && !FileAr->IsError() ){  //loop until done
		oldFrame = ServerFrameNum;
		OldTime = ServerPacketTime;
		*FileAr << ServerFrameNum;
		if (FileAr->AtEnd() || FileAr->IsError())
			return ServerPacketTime;
		*FileAr << ServerPacketTime;
		//	GLog->Logf(TEXT("time is %f"),ftime.GetFloat());
		if (FileAr->AtEnd() || FileAr->IsError())
			return ServerPacketTime;
		if(ServerPacketTime > GoalTime)
		{
			FTime OutTime = ServerPacketTime;
			FileAr->Seek(FileAr->Tell() - sizeof(ServerFrameNum) - sizeof(ServerPacketTime));
			if (bPacketRead){ //otherwise, readto is exact time!
				ServerPacketTime = OldTime;
				ServerFrameNum = oldFrame;
			}
			Time = ServerPacketTime;			//synch everything on jumps!
			FrameNum=ServerFrameNum;
			return OutTime;
		}
		*FileAr << PacketBytes;
		if (FileAr->AtEnd() || FileAr->IsError())
			return ServerPacketTime;
		seekTo=FileAr->Tell() + PacketBytes;
		if (seekTo>FileAr->TotalSize()) //stops crashes on truncated demos
			return ServerPacketTime;
		if (!bPacketRead)
			FileAr->Seek(seekTo); //move ahead by packetbytes
		else{
			FileAr->Serialize( Data, PacketBytes );
			ServerConnection->ReceivedRawPacket( Data, PacketBytes );
		}

	}
	return ServerPacketTime;
	unguard;
}
void UuDemoDriver::getTime(){
	guard(UuDemoDriver::getTime);
	int seekTo;
	int oldPos = FileAr->Tell();
	DWORD PacketBytes; 
	while (!FileAr->AtEnd() && !FileAr->IsError() ){  //loop until done
		*FileAr << TotalFrames;
		if (FileAr->AtEnd() || FileAr->IsError())
			break;
		*FileAr << TotalTime;
		//	GLog->Logf(TEXT("time is %f"),ftime.GetFloat());
		if (FileAr->AtEnd() || FileAr->IsError())
			break;
		*FileAr << PacketBytes;
		if (FileAr->AtEnd() || FileAr->IsError())
			break;
		seekTo=FileAr->Tell() + PacketBytes;
		if (seekTo>FileAr->TotalSize()) //stops crashes on truncated demos
			break;
		FileAr->Seek(seekTo); //move ahead by packetbytes
	}
	FileAr->Seek(oldPos);

	unguard;
}

UBOOL UuDemoDriver::InitConnect( FNetworkNotify* InNotify, FURL& ConnectURL, FString& Error )
{
	guard(UuDemoDriver::InitConnect);
	if( !UNetDriver::InitConnect( InNotify, ConnectURL, Error ) )
		return 0;
	if( !InitBase( 1, InNotify, ConnectURL, Error ) )
		return 0;

	Speed=1;
	RealDilation=1;
	// Playback, local machine is a client, and the demo stream acts "as if" it's the server.
	ServerConnection = new UAdvancedConnection( this, ConnectURL );
	ServerConnection->CurrentNetSpeed = 1000000;
	ServerConnection->State        = USOCK_Pending;
	FileAr                         = GFileManager->CreateFileReader( *DemoFilename );
	if( !FileAr )
	{
		Error = FString::Printf( TEXT("Couldn't open demo file %s for reading"), *DemoFilename );//!!localize!!
		return 0;
	}
	getTime(); //figure out the time
	LoopURL = ConnectURL;
	ClientThirdPerson	= ConnectURL.HasOption(TEXT("3rdperson")); //disallow option. only for spectators!
	TimeBased			= ConnectURL.HasOption(TEXT("timebased"));
	NoFrameCap          = ConnectURL.HasOption(TEXT("noframecap"));
	if (NoFrameCap) //can't have both!!!!!
		TimeBased = false; 
	Loop				= ConnectURL.HasOption(TEXT("loop"));
	MessagePlay			= ConnectURL.HasOption(TEXT("messageread"));
	if (MessagePlay)
		LoopURL.Op.RemoveItem(TEXT("messageread")); //hack
	return 1;
	unguard;
}
IMPLEMENT_CLASS(UuDemoDriver);

//begin custom demo connection:
void UAdvancedConnection::StaticConstructor()
{
	guard(UAdvancedConnection::StaticConstructor);
	unguard;
}

UAdvancedConnection::UAdvancedConnection( UNetDriver* InDriver, const FURL& InURL )
: UDemoRecConnection( InDriver, InURL )
{
	guard(UAdvancedConnection::UAdvancedConnection);
	unguard;
}

UuDemoDriver* UAdvancedConnection::GetDemoDriver() //new driver reading
{
	return (UuDemoDriver *)Driver;
}

void UAdvancedConnection::HandleClientPlayer( APlayerPawn* Pawn )
{
	guard(UAdvancedConnection::HandleClientPlayer);
	UViewport* Viewport = NULL;
	if (GetDemoDriver()->ClientHandled)
		return;
	GetDemoDriver()->ClientHandled = true;
	if( GetDriver()->ClientThirdPerson )
	{
		guard(SpawnSpectator);

		UClass* SpectatorClass = StaticLoadClass( APawn::StaticClass(), NULL, TEXT("udemo.DemoPlaybackSpec"), NULL, LOAD_NoFail, NULL );
		check(SpectatorClass);

		FVector Location(0,0,0);
		FRotator Rotation(0,0,0);

		guard(FindPlayerStart);
		for( INT i=0; i<Pawn->XLevel->Actors.Num(); i++ )
		{
			if( Pawn->XLevel->Actors(i) && Pawn->XLevel->Actors(i)->IsA(APlayerStart::StaticClass()) )
			{
				Location = Pawn->XLevel->Actors(i)->Location;
				Rotation = Pawn->XLevel->Actors(i)->Rotation;
				break;
			}
		}
		unguard;

		guard(SpawnDemoSpectator);
		Pawn = CastChecked<APlayerPawn>(Pawn->XLevel->SpawnActor( SpectatorClass, NAME_None, NULL, NULL, Location, Rotation, NULL, 1, 0 ));
		check(Pawn);
		check(Pawn->XLevel->Engine->Client);
		check(Pawn->XLevel->Engine->Client->Viewports.Num());
		guard(AssignPlayer);
		Viewport = Pawn->XLevel->Engine->Client->Viewports(0);
		Viewport->Actor->Player = NULL;
	//	Viewport->Actor->SetPlayer( Viewport );
		Pawn->SetPlayer( Viewport );
		check (Pawn->Player);
		Viewport->Actor->Role	    = ROLE_Authority;
		Viewport->Actor->ShowFlags = SHOW_Backdrop | SHOW_Actors | SHOW_PlayerCtrl | SHOW_RealTime;
		Viewport->Actor->RendMap   = REN_DynLight;	
		Pawn->bNetOwner = 1;
		Pawn->Physics   = PHYS_Flying;
		Viewport->Input->ResetInput();
		//generate the interface object:
		guard(MakeInterface);
		UClass* DemoDriverClass = StaticLoadClass( UObject::StaticClass(), NULL, TEXT("udemo.DemoInterface"), NULL, LOAD_NoFail, NULL );
		GetDemoDriver()->Interface = (UDemoInterface*)ConstructObject<UObject>( DemoDriverClass );
		check(GetDemoDriver()->Interface);
		GetDemoDriver()->Interface->DemoDriver=GetDemoDriver();
		GetDemoDriver()->Interface->DemoSpec=Pawn; //BE SURE THIS IS THE SPAWNED PAWN!!!!
		if (!GetDemoDriver()->TimeBased){
			if (GetDemoDriver()->NoFrameCap)
				GetDemoDriver()->Interface->PlayBackMode=2;
			else
				GetDemoDriver()->Interface->PlayBackMode=1;
		}
		else
			GetDemoDriver()->Interface->PlayBackMode=0;
		GetDemoDriver()->Interface->bDoingMessagePlay = GetDemoDriver()->MessagePlay;
		GetDemoDriver()->Interface->mySpeed=1;
		GetDemoDriver()->Interface->eventLinkToPlayer(NULL); //this should be the pawn!!!
		unguard;
/*		int n;
		int o = GetDemoDriver()->FileAr->Tell();
		*GetDemoDriver()->FileAr << n;
		*GetDemoDriver()->FileAr << GetDemoDriver()->StartTime; //set start time!
		GetDemoDriver()->FileAr->Seek(o);
		*/
		unguard;
		unguard;
		unguard;

		// Mark this connection as open.
		State = USOCK_Open;		
	}
	else
		UNetConnection::HandleClientPlayer(Pawn); //remove

	if (Viewport == NULL)
		Viewport = Pawn->XLevel->Engine->Client->Viewports(0);
	// Setup music for demo     uh.. this is lame! fix it!~~~~~!!!
	Viewport->Actor->Song        = Pawn->Level->Song;
	Viewport->Actor->SongSection = Pawn->Level->SongSection;
	Viewport->Actor->CdTrack     = Pawn->Level->CdTrack;
	Viewport->Actor->Transition  = MTRAN_Fade;
	check(Pawn->XLevel->Engine->Client);
	check(Pawn->XLevel->Engine->Client->Viewports.Num());

	unguard;
}
IMPLEMENT_CLASS(UAdvancedConnection);



